''***************************************
''*  z8Busdrive v2.2  Objekt CALC       *
''*  Author: Uwe Nickel                 *
''*  Copyright (c) 2011 by UN-Soft      *
''*  See end of file for terms of use.  *
''***************************************

' 
 
CON
 

VAR   
    long  cog
    

PUB start (bws_adr,bws_len,bmp_adr,bmp_len,col_adr,col_len,vgamod_adr,calccmd_adr,xyzdata_adr)
     scr_buff    := bws_adr
     len         := bws_len   
     bmp_buff    := bmp_adr
     len_bmp     := bmp_len
     col_buff    := col_adr
     len_col     := col_len
     vgamode_adr := vgamod_adr
     calc_cmd    := calccmd_adr
     calc_adr    := xyzdata_adr
     

      
     '' Stop driver - frees a cog
     if cog
       cogstop(cog~ -  1)
     
   
     cog := cognew(@CALC,0) + 1                                       'Berechnung-Cog starten
               

DAT 'Berechnung- Cog
org 0
'******************************************************************************************************
'---- Mainloop ----------------------------------------------------------------------------------------
'******************************************************************************************************                  
CALC              mov Mem, par
                  rdlong vgamode, vgamode_adr      'VGA-Start-Mode holen
                  rdlong temp2, calc_adr           'Standardfarben holen
                  call #col_set                    'und setzen
                  mov temp2, #$0                   'Cmd mit 0 initialisieren
                   
Cmdx              rdlong temp2, calc_cmd           'einlesen Kommando aus bergabezelle nach Variable
                  cmp temp2, #$0           wz      'testen auf 0
         if_z     jmp #Cmdx                        'zurck, solange 0
                
                  mov temp,#0                      'sonst 0 setzen
                  wrlong temp, calc_cmd            'und nach bergabzelle schreiben
         
                  cmp temp2, #$10          wz       'Cmd = Monitor Content?
         if_z     jmp #bws2bmp                      'ja
                  cmp temp2, #$21          wz
         if_z     jmp #set_col         
                  cmp temp2, #$22          wz
         if_z     jmp #set_moni
                  cmp temp2, #$24          wz
         if_z     jmp #clear_bmp
                  cmp temp2, #$25          wz
         if_z     jmp #set_bmp
                                                     
                  jmp #Cmdx
'********************************************************************************************************

'********************************************************************************************************
'---- Subroutinen Monitor -------------------------------------------------------------------------------
'********************************************************************************************************
clear_bmp         mov temp2, #0     
                  call #bmp_set
                  jmp #Cmdx                         'und zurck
                  
'------------------------------------------------------------------------------------------------------ 
set_moni          rdlong vgamode, vgamode_adr       'Ausgabemodus einlesen (4 Bytes)
                  test vgamode, #$08       wz       'Bit 3 testen, ob Cls
         if_nz    jmp #clear_bmp                    'sonst Bitmappuffer lschen
                  jmp #Cmdx                         'und zurck
                  
'------------------------------------------------------------------------------------------------------ 
set_bmp           rdlong temp2, calc_adr            'auszugebenden Wert einlesen
                  call #bmp_set                     'und nach Bitmappuffer schreiben
                  jmp #Cmdx                         'und zurck
                  
'------------------------------------------------------------------------------------------------------ 
set_col           rdlong temp2, calc_adr
                  call #col_set
                  jmp #Cmdx

'------------------------------------------------------------------------------------------------------
bws2bmp           mov temp, vgamode                 'vga-mode fr Berechnung Y-Position holen   
                  shr temp, #16                     'Zeilenanzahl extrahieren und
                  and temp, #$FF                    'maskieren
                  mov temp_cnt,#80                  'Zeilenlnge 
                  shl temp_cnt, temp                'multiplizieren mit Zeilenzahl
                  
                  mov temp2, vgamode                'vga-mode fr Berechnung X-Position holen
                  shr temp2, #24                    'extrahieren
                  shl temp2, #2                     'X-Offset berechnen (temp2*4 wegen long)
                  add temp_cnt, temp2               'zu Y-Offset addieren 
                  mov bmp_ptr, bmp_buff             'Adresse bitmapbuffer   
                  add bmp_ptr, temp_cnt             'Berechnen first screenbuffer long  
                  mov scr_ptr, scr_buff             'Adresse screenbuffer nach Pointer
                  mov scr_end, scr_buff             'Pointer nach screenend variable
                  add scr_end, len                  'Berechnen Endadresse
                  
                  test vgamode, #1         wz       'Zeile 0 anzeigen?
   if_z           add scr_ptr, #$38                 'Ja, dann Bilschirmpointer neu berechnen
  
                  mov yzm, vgamode                  'vga-mode fr Berechnung Y-Zoom holen 
                  shr yzm, #8                       'extrahieren und
                  and yzm, #$0f                     'maskieren  
 
                  mov xz, vgamode                   'vga-mode fr Berechnung X-Zoom holen 
                  shr xz, #12                       'extrahieren und  
                  and xz, #$0f                      'maskieren
                                
                  cmp xz, #2               wz
   if_nz          jmp #:zoom1
                  mov xval, #2                     
                  mov rorval, #8
                  mov mux_mask, #$ff
                  mov muxval, #4
                  mov xoffset,#4*4
                  jmp #:start

:zoom1            mov xval, #1                       
                  mov rorval, #4
                  mov mux_mask, #$0f
                  mov muxval, #8
                  mov xoffset,#4*12    
                      
:start            mov x1, #8                        '1 line = 16 screenbuffer longs
:mx               rdbyte temp2, scr_ptr             'read screenbuffer -> temp2
                  shl temp2, #24                    'MSB <-- LSB of temp2 long
                  mov x3, xval                      'x-zoomfactor 
:mz               mov temp3, muxval                 'expand 1byte =8bits

:m1               rol temp2,#1              wc      'rotate left 1bit, bit0 --> C

                  test vgamode, #$4         wz      'Test vgamode auf invertieren
   if_z           muxnc temp,mux_mask               'C --> pixel b0...b7
   if_nz          muxc temp,mux_mask                'C --> pixel b0...b3  
                  ror temp,rorval                   'rotate right pixel's 
                  djnz temp3, #:m1                  'do it temp3 -times
     
                  mov ptr, bmp_ptr                  'set temporary line pointer   
                  mov x4,yzm
                  add x4, #1
:zy               wrlong temp, ptr                  'write to bitmapbuffer - second line   
                  add ptr, #80
                  djnz x4,#:zy
                  add bmp_ptr, #4                   'next bitmapbuffer long    
                 
                  djnz x3, #:mz                     'do x - zoom
                  
                  add scr_ptr, #1                   'next screenbuffer byte 
                  djnz x1, #:mx                     'do until lines end

                  mov x4, yzm
                  cmp x4, #0                wz
     if_z         jmp #:m2
:zy2              add bmp_ptr, #80                
                  djnz x4,#:zy2
:m2               add bmp_ptr, xoffset              'next new bitmapbuffer line position  
                 
                  cmp scr_ptr,scr_end       wz      'end screenbuffer ?
    if_nz         jmp #:start                       'jump back if not end
 
                  jmp #Cmdx
                  
'-------------------------------------------------------------------------------------------------------
'---- Common -Parts  -----------------------------------------------------------------------------------
'-------------------------------------------------------------------------------------------------------
col_set           mov temp3, temp2                 'Verdopplung word --> long
                  shl temp3, #16
                  or  temp2, temp3 
                  mov len_ptr, len_col             'Lnge Farbspeicher
                  shr len_ptr, #1                  'Umrechnen auf Long
                  mov scr_ptr, col_buff            'Adresse Farbspeicher
                  jmp #fill_block
bmp_set           mov len_ptr, len_bmp              'Lnge Bitmap-Puffer nach Pointer
                  mov scr_ptr, bmp_buff             'Adresse Bitmap-Puffer nach Pointer

fill_block        wrlong temp2, scr_ptr             'Bitmappufferadresse bescheiben 
                  add scr_ptr, #4                   'nchste Long-Adresse
                  djnz len_ptr, #fill_block         'zurck, wenn Lnge grer 0
fill_block_ret
bmp_set_ret
col_set_ret       ret                               'und zurck
                   
'------------------------------------------------------------------------------------------------------                                       
 
'---------------------------------------------------------------------------------------------------------

'*********************************************************************************************************
'---- Data & Variable ------------------------------------------------------------------------------------
'*********************************************************************************************************                    
    
 scr_buff      long  0      
 bmp_buff      long  0
 col_buff      long  0 
 len           long  0 
 len_bmp       long  0
 len_col       long  0   
 vgamode_adr   long  0
                                  
 calc_cmd      long  0           
 calc_adr      long  0
 


Mem            res   1
vgamode        res   1
temp           res   1
temp2          res   1
temp3          res   1
temp_cnt       res   1
ptr            res   1
x1             res   1  
rorval         res   1
mux_mask       res   1
muxval         res   1
xval           res   1  
x3             res   1
xz             res   1
x4             res   1 
scr_ptr        res   1
scr_end        res   1 
bmp_ptr        res   1
len_ptr        res   1
yzm            res   1
zrm            res   1
xoffset        res   1