''***************************************
''*  z8Busdrive v2.4  for TINY2012      *
''*  Author: Uwe Nickel                 *
''*  Copyright (c) 2012                 *
''*  See end of file for terms of use.  *
''***************************************

' Version mit Bildwiederholzwischenspeicher fr den Z8, Bildschirm-Umrechnung
' und andere Bildschirmbefehle in separatem Cog
' Erzeugung Systemtakt durch Cog0
' AY_Sound und RS232-IO
' Kommandoauswahlschleife mit Subkategorien
 
CON

        _clkmode        = xtal1 + pll16x
        _xinfreq        = 5_000_000
'--------------------------------------------------------------------------------
' Festlegungen Hardware
'--------------------------------------------------------------------------------
' Koppelbus (IO-Port's) im Kommando-Cog

        _DB             = $0000_00_FF  'I/O -Datenbus D0..7, aufeinanderfolgende Pins!'
        _DB0            = 0            'I/0 -niederwertigster Datenbuspin
        _RD             = 8            'I   -Leseanforderung'
        _WR             = 9            'I   -Schreibanforderung'
        _DRDY           = 10           'O   -bereit zum Empfang/senden eines Bytes'
        _CRDY           = 11           'O   -Commando fertig, bereit zum Empfang neues CMD'
        _SYSCLK         = 14           'O   -Systemtakt fr CPLD/Z8
        _SYSRES         = 15           'O   -RESET-Signal
'--------------------------------------------------------------------------------
' externe Gerte (IO-Port's) 

         vgapin         = 16           'VGA - ab Pin16 acht Pins  
         kbdata         = 26           'Tastatur-Daten
         kbclock        = 27           'Tastatur-Clock
         TxPin          = 30           'Portpin serielle Ausgabe
         DtrPin         = 25           'Portpin DTR
         RxPin          = 31           'Portpin serielle Eingabe
         CtsPin         = 24           'Portpin CTS
         sound_l        = 13           'Soundausgabe links
         sound_r        = 12           'Soundausgabe rechts
         
'---------------------------------------------------------------------------------------------------
' Festlegungen Software
'---------------------------------------------------------------------------------------------------
' Kommando-Steuerung

         CmdProlog      = $AA          'Prologbyte zur Ankndigung eines Cmd 
         master_cmd     = 0            'MasterKommando von Cog0 an Cmd-Cog
                                       '0 -Cmd-Cog liest von Bus, xx -Cog0 steuert
         SysFreq        = 16_000000    'Standardsystemtakt in Hz  (16 MHz)
'--------------------------------------------------------------------------------------------------- 
' Bildschirm (Memory etc.)
 
         lencol         = $12C         'Gre Farbspeicher in Word
         lenbmp         = 4800         'Gre Bitmap-Speicher in Longs
         lenx           = $200         'Gre Bildspeicher TINY in Byte
         stdcol         = $FF_09       'Vordergrundfarbe(wei)_ Hintergrundfarbe(blau)                    
       ' stdmodus       = $01_01_21_00 'Ausgabemodus: xp_yp_zxzy_x/x/x/x/cls/im/tm/zr
         stdmodus       = $07_07_00_08 'Spasswert fr Startshow
''..................................................................................................
''         xp - X-Position auf Schirm in Spalten (1Spalte = 1long)
''         yp - Y-Position auf Schirm in Zeilen  (1Zeile  = 20long's)
''         zx - X-Zoomfactor ("1" or "2")
''         zy - Y-Zoomfactor ()
''        cls - Clear Screen vor Ausgabe neuer Werte ("0"- no CLS, "1"- CLS) 
''         im - Invers-Mode fr Bildschirmspeicher ("0"  or "1")
''         tm - Tile-Mode fr VGA-Driver, y-Direction: lines per Tile, Value of equal lines
''                                          Mode "0" :   8               4
''                                          Mode "1" :   16              2
''         zr - unbenutzte 1.Zeile vom TINY-Screen: show "1" or hide "0"
''..................................................................................................
''         xp_          = 1            'Position links, 1.Spalte
''         yp_          = 1            'Position oben, 1.Zeile  
''         zx_          = 2            'Zoom doppelte Breite
''         zy_          = 1            'Zoom Hhe
''        cls           = 0
''         im_          = 0            'keine inverse Darstellung
''         tm_          = 0            '8 Zeilen pro Tile
''         zr_          = 0            'ungenutzte Zeile ausblenden
        
'--------------------------------------------------------------------------------
' Serielle Ein-/Ausgabe
         RxMode         = 0
         CtsMode        = 0
         TxMode         = 0            'TX-Daten nicht invertiert
         DtrMode        = 1            'DTR-Handshake, high-aktiv  
         Baudrate       = 1200         'Baudrate  fr senden und empfangen
  
'--------------------------------------------------------------------------------
' Soundausgabe AY-Chip-Emulator

         ch1_tone       = true         'Kanal 1 Tonausgabe
         ch2_tone       = false        'Kanal 2 kein Ton
         ch3_tone       = true         'Kanal 3 Tonausgabe
         ch1_noise      = false        'Kanal 1 kein Rauschen
         ch2_noise      = true         'Kanal 2 Rauschen an
         ch3_noise      = false        'Kanal 3 kein Rauschen
         envelope       = 0            'Envelope Art "high to low"
         envrate        = 845          'Envelope Verlauf schnell
         stdbeep        = $0f32_2422   'Standard-Beep
         lensndmem      = 512          'Lnge User-Ram f. nachladbare Pattern in Byte
         
'--------------------------------------------------------------------------------

VAR   
    long  cog
    long  sync
    byte  scr_buffer  [lenx ]  
    word  col_base    [lencol]
    long  bitmap_base [lenbmp]
    long  vgamodi
    byte  sndbuff     [lensndmem]
    long  mode_base
    long  datakb
    long  CommPtr
    long  xxxdata
    long  xyzdata
    long  fullcmd
    long  maincmd
    long  calccmd
    long  mastercmd
    long  sysfrq
       
OBJ  kb            : "keybdrv-jute2"    
     moni          : "vga-jute"
     Commser       : "JDCogSerial-jute3" 
     ay            : "AYcog-jute"
     calc          : "calc-jute" 
     
PUB Main

'Signalmasken
     handshake     := |<_CRDY | |<_DRDY             'Handshake- Signale 
     crdy_val      := 0                             'crdy=L,drdy=L
     drdy_val      := |<_CRDY                       'crdy=H,drdy=L
     rdbus_mask    := |<_WR                         'WR=H,RD=L
     wrbus_mask    := |<_RD                         'WR=L,RD=H
     data_mask     := _DB                           'Datenbuspins 0...7
     data0         := _DB0                          'lowest DB_Pin
         
'Initialisierungs- und Standardwerte     
     cmdlabel      := CmdProlog                     'PrologByte fr Start eines Kommandos
     vgamodi       := stdmodus                      'Init-Wert Darstellungsmodus
     mode_base     := (stdmodus >> 1) & 1           'Tile-Mode fr VGA-Treiber       
     xyzdata       := stdcol                        'Init-Wert Farben fr Vorder-und Hintergrund
     mastercmd     := master_cmd                    'Init-Wert Masterkommando
     fullcmd       := 0                             'Init-Wert Sounddaten/kommando
     sysfrq        := SysFreq                       'Init-Wert System-Clock
        
'HUB-Ram Speicheradressen     
     mode_b_adr    := @mode_base                    'Adresse Merkzelle Tile-Mode
     scr_buff      := @scr_buffer                   'Anfangsadresse Array des Bildschirmpuffers
     bmp_buff      := @bitmap_base                  'Anfangsadresse Array des Bitmap-VGA-Puffers  
     col_buff      := @col_base                     'Anfangsadresse Array des Farb-VGA-Puffers  
     vgamode_adr   := @vgamodi                      'Adresse Merkzelle Ausgabemodus 
     sndbuff_adr   := @sndbuff                      'Anfangsadresse Array des Soundpuffers 
     key_dat       := @datakb                       'Adresse bergabezelle Tastaturwert
     data_adr      := @xxxdata                      'Adresse bergabezelle Werte fr Sound (an Cog0)
     full_cmd      := @fullcmd                      'Adresse bergabezelle Kommando fr Sound (an Cog0)
     calc_adr      := @xyzdata                      'Adresse bergabezelle Werte fr Berechnung-Cog 
     calc_cmd      := @calccmd                      'Adresse bergabezelle Kommando fr Berechnung-Cog  
     mastercmd_adr := @mastercmd                    'Adresse Merkzelle Masterkommando fr CMD-Cog
     sysfrq_adr    := @Sysfrq                       'Adresse Merkzelle Systemfrequenz 

'Reset L setzen und halten   
     SYSReset (0)                                   

'Takterzeugung fr CPLD/Z8 mit Standardwert starten
     SetSpeed(_SYSCLK, SysFreq)                     'Berechnen und Register setzen
     DIRA[_SYSCLK]~~                                'I/O-Pin Taktausgang setzen
     
'Reset auf H       
     SYSReset (1)                                   

'VGA-Treiber starten       
     moni.start (vgapin,@col_base,@bitmap_base,@mode_base,@sync)
     
'Berechnungs_Cog starten         
     calc.start(@scr_buffer,lenx,@bitmap_base,lenbmp,@col_base,lencol,@vgamodi,@calccmd,@xyzdata)
        
'Keyboard starten       
     kb.start(kbdata, kbclock,@datakb)                                
     
'RS232-Ein/Ausgabe starten
     CommPtr := Commser.start(RxPin,RxMode,CtsPin,CtsMode,TxPin,TxMode,DtrPin,DtrMode, BaudRate)    
     RxPtr := CommPtr                                                  
     TxPtr := CommPtr + 4

'AY-Sound starten         
     ay.start(sound_l, sound_r)                     'AY-Cog starten                   
     ay.enableTone(ch1_tone,ch2_tone,ch3_tone)      'AY-channel Tonausgabe (lead, bass) setzen
     ay.enableNoise(ch1_noise,ch2_noise,ch3_noise)  'AY-channel Rauschen (drum) setzen
     ay.setEnvelope(envelope, envrate)              'AY-Envelope Art und Verlauf setzen
                                                                      
'Kommando-Cog starten   
     cog := cognew(@START,0) + 1                                      

     mastercmd  :=  $01
        
' Hauptschleife
     repeat
        case mastercmd                              'Testen Aktionshoheit
        
          $0         : SPINCMD                      'solange MasterKommando =0 SPIN-Kommandos
          other      : MACRO                        'sonst Makro  (mastercmd = Makronummer)
          
PUB MACRO
'Kommandos Makro's in Spin

     case mastercmd
       $01           : startshow
                                               '
     mastercmd := 0                                 'Ende Makro, Rckgabe Aktionshoheit
    
PUB SPINCMD 
'Kommandos SPIN-Befehle (Sound etc)
     repeat while  fullcmd == 0                                'warten auf Spin-Cmd-Nummer
       
     maincmd := (fullcmd & $0000_FF00)>> 8                     'Nr. extrahieren
     case maincmd
        
       $40           : ay.beep(stdbeep)                        'Ausgabe Standardwert
         
       $42, $49, $4B : ay.beep(xxxdata)                        'xxxdata = auszugebender Wert 

       $41, $46      : ay.beep(beepTable[fullcmd.byte[0]])     'Byte 0 enthlt Wert
         
       $43, $4C      : ay.single_note(xxxdata)                 'xxxdata = auszugebender Wert
                 
       $44, $47      : ay.play_music (@@padr[fullcmd.byte[0]]) 'Byte 0 enthlt Wert 
         
       $48, $4A      : ay.play_music (xxxdata)                 'xxxdata = Adresse im Speicher

       $F9           : SetSpeed (_SYSCLK, sysfrq)              'sysfrq  = Taktfrequenz in Merkzelle
          
     fullcmd := 0                                              'SPIN-Cmd fertig
     return
     
PUB SetSpeed(Pin, Freq)  | s, d, clk, frq 
     
    clk  := CLKFREQ
    Freq := Freq #> 3_000000 <# 40_000000     'Eingrenzen Frequenzbereich (3...40MHz)      
    d    := >|((Freq - 1) / 1_000_000)        'bestimme PLLDIV
    s    := 4 - d                             'bestimme shift fr Berechnung FRQA-Wert
    
'Setze CTRA mit Pll-Mode | PLLDIV | PINA
    CTRA := constant(%00010 << 26) | (d << 23) | Pin
    
'Berechne und setze FRQA-Wert
    if s > 0
      Freq <<=  s              
    if s < 0
      clk  <<= -s

    repeat 32
      frq <<= 1
      if Freq => clk
         Freq -= clk
         frq++
      Freq <<= 1 
    
    FRQA := frq

PUB SYSReset(state)
    case state
      0:
            OUTA[_SYSRES]~                                 'Reset = L  
            DIRA[_SYSRES]~~                                'I/O-Pin Resetausgang setzen
      1:
            OUTA[_SYSRES]~~                                'Reset = H
            DIRA[_SYSRES]~                                 'I/O-Pin wieder als Eingang setzen

PUB startshow    | s, t
       waitcnt(80_000000+cnt)

 s:= $01_01_00_00
 t:= 25_000_000
 
vgamodi := $07_07_00_08   
       repeat 6
         vgamodi := vgamodi - s
         calccmd := $22
         t := t - t/10   
         waitcnt(t+cnt)
      vgamodi := $01_01_11_08
       calccmd := $22     
       waitcnt(50_000000+cnt)
       vgamodi := $01_01_20_08
       calccmd := $22     
       waitcnt(50_000000+cnt)
       vgamodi := $01_01_21_08
       calccmd := $22     
      fullcmd := $0000_4701
      SPINCMD
       
return
 
DAT       'jetzt TESTWERTE!!!!, sonst hier Notenwerte
beepTable long $0f32_2422, $0812_4438, $0f3a_1422, $0f32_2422, $0f32_2422, $0f32_2422, $0f32_2422, $0f32_2422, $0f32_2422, $0f32_2422  
DAT       'nur Testpattern!!!
padr      word @p1, @p2, @p3

            'Speed|Ch3|Ch2|Ch1    
p1        long  $1010_4400 
          long  $0820_0010 
          long  $0830_0020 
          long  $0200_0030 
          long  $0100_0009 
          long  $0000_0000 'Silence
          long  $FFFF_FFFF 'Song end

p2        long  $1030_4440 
          long  $0820_0030 
p3        long  $0810_0020 
          long  $0200_0010 
          long  $0100_0009 
        
          long  $0000_0000 'Silence
          long  $FFFF_FFFF 'Song end


DAT  'Command- Cog
org 0
'******************************************************************************************************
'---- Mainloop ----------------------------------------------------------------------------------------
'******************************************************************************************************  
START             mov dira, handshake             'handshake auf Ausgang
                  mov outa, handshake             'Cmd und Data not ready setzen
                  mov Mem, Par                    'Adresse einlesen
                 
Cmdxy             wrlong cmdnr, calc_cmd          'Cmd nach Merkzelle fr Berechnungs-Cog           
Cmdxx             rdlong temp2, mastercmd_adr     'Masterkommando einlesen
                  cmp temp2, #$80           wc    'vergleichen ob < 80h
   if_nc          mov temp2, cmdnr                'wenn nicht, dann Cmd-Nr nach Variable
   if_nc          jmp #Cmd                        'Sprung, wenn nicht, also Spin-Makro mit Cog1- Sperre
                  call #cmdwait                   'warten bis Command-label recieved
                  call #byte_in                   'dann lies CMD-Nr.
Cmd               mov cmdnr, temp2                'schreibe nach cmdnr
                  mov cmdgroup, temp2             'schreibe nach cmdgroup
                  shr cmdgroup, #4                'extrahiere Command-Group
             
'------------------------------------------------------------------------------------------------------                         
'---- Commandselection --------------------------------------------------------------------------------
'------------------------------------------------------------------------------------------------------
'.....Keyboard.........................................................................................                     
                  cmp cmdnr, #$01           wz    'CMD       = Keyboard_1?
   if_z           jmp #keyb1                      'ja
                  cmp cmdnr, #$02           wz    'CMD       = Keyboard_2?
   if_z           jmp #keyb2                      'ja

'.....VGA..............................................................................................      
                  cmp cmdnr, #$10           wz    'CMD       = Monitor Content?                           
   if_z           jmp #screen                     'ja
                  cmp cmdnr, #$20           wz    'CMD       = Monitor Farben je Tile setzen?
   if_z           jmp #colxx                      'ja
                  cmp cmdnr, #$21           wz    'CMD       = Monitor einheitliche Farben gesamter Bildschirm?
   if_z           jmp #colfgbg                    'ja   
                  cmp cmdnr, #$22           wz    'CMD       = Monitorausgabeparameter setzen? 
   if_z           jmp #set_moni                   'ja
                  cmp cmdnr, #$23           wz    'CMD       = Bitmappuffer beschreiben? 
   if_z           jmp #set_bmp                    'ja
                  cmp cmdnr, #$24           wz    'CMD       = Bitmappuffer lschen mit 00? 
   if_z           jmp #cls_bmp                    'ja   
                  cmp cmdnr, #$25           wz    'CMD       = Bitmappuffer beschreiben mit einer Long? 
   if_z           jmp #wr1_bmp                    'ja  

       
                  cmp cmdgroup, #$3         wz    'CMD-Group = RS-232? 
   if_z           jmp #rs232                      'ja                  
                  cmp cmdgroup, #$4         wz    'CMD-Group = Soundausgabe? 
   if_z           jmp #sound                      'ja                  
                  cmp cmdgroup, #$E         wz    'CMD-Group = Ausgabe Statuswerte? 
   if_z           jmp #get_info                   'ja                  
                  cmp cmdgroup, #$F         wz    'CMD-Group = Steuerungskommandos? 
   if_z           jmp #control                    'ja
   
                  jmp #Cmdxx
'******************************************************************************************************                   
'------------------------------------------------------------------------------------------------------     
'---- Commandgroups -----------------------------------------------------------------------------------
'------------------------------------------------------------------------------------------------------         
'......RS-232..........................................................................................

rs232             cmp cmdnr, #$30           wz    'CMD = PinInfo?
   if_z           jmp #pininfo                    'ja
                  cmp cmdnr, #$31           wz    'CMD = Status serial In/Out?
   if_z           jmp #seriostat                  'ja

'......RS-232 Out......................................................................................   
                  cmp cmdnr, #$32           wz    'CMD = 1 Byte ohne Prfung nach Puffer?
   if_z           jmp #seroutbyte                 'ja
                  cmp cmdnr, #$33           wz    'CMD = 1 Byte seriell Out nach Puffer, Abbruch, wenn voll?
   if_z           jmp #serout1                    'ja   
                  cmp cmdnr, #$34           wz    'CMD = 1 Byte seriell Out nach Puffer, warten, wenn voll?
   if_z           jmp #serout2                    'ja
                  cmp cmdnr, #$35           wz    'CMD = nnnn-Bytes im Block aus Puffer ausgeben mit ggf. warten?
   if_z           jmp #rdtxdata                   'ja

'......RS-232 In.......................................................................................
                  cmp cmdnr, #$36           wz    'CMD = 1 Byte ohne Prfung von Puffer einlesen?
   if_z           jmp #serin0                     'ja
                  cmp cmdnr, #$37           wz    'CMD = 1 Byte seriell In aus Puffer,Abbruch wenn kein Byte?
   if_z           jmp #serin1                     'ja   
                  cmp cmdnr, #$38           wz    'CMD = 1 Byte seriell In aus Puffer, warten auf Byte?
   if_z           jmp #serin2                     'ja 
                  cmp cmdnr, #$39           wz    'CMD = nnnn-Bytes im Block aus Puffer einlesen mit ggf. warten?
   if_z           jmp #wrrxdata                   'ja
   
                  jmp #Cmdxx
                  
'......Sound...........................................................................................
  
sound             cmp cmdnr, #$40           wz    'CMD = Standard Beep (expected single Command)?
   if_z           jmp #beep                       'ja
                  cmp cmdnr, #$41           wz    'CMD = vordefinierter Beep aus Prop (expected Command + Beep-Nr.)?
   if_z           jmp #snd_nr                     'ja
                  cmp cmdnr, #$42           wz    'CMD = bergebener Beep (expected Command + 4 Data Byte's)?
   if_z           jmp #snd_get                    'ja   
                  cmp cmdnr, #$43           wz    'CMD = single Note, endlos (expected Command + 4 Data Byte's)?
   if_z           jmp #snd_get                    'ja
                  cmp cmdnr, #$44           wz    'CMD = play Melody/Pattern aus Prop(expected Command + Pattern-Nr.)?
   if_z           jmp #snd_nr                     'ja
                  cmp cmdnr, #$45           wz    'CMD = Test Sound ready (expected Command, write back 1 Statusbyte)?
   if_z           jmp #sndrdy                     'ja
                  cmp cmdnr, #$46           wz    'CMD = vordefinierter Beep aus Prop, warten bis Ende (expected Command + Beep-Nr.)?
   if_z           jmp #snd_nr_wait                'ja
                  cmp cmdnr, #$47           wz    'CMD = play Melody/Pattern aus Prop, warten bis Ende  (expected Command + Pattern-Nr.)?
   if_z           jmp #snd_nr_wait                'ja
                  cmp cmdnr, #$48           wz    'CMD = play Melody/Pattern aus Soundpuffer-RAM (expected Command + Pattern-Nr.)?
   if_z           jmp #memsnd_nr                  'ja
                  cmp cmdnr, #$49           wz    'CMD = play beep aus Soundpuffer-RAM (expected Command + Beep-Nr.)?
   if_z           jmp #membeep_nr                 'ja
                  cmp cmdnr, #$4A           wz    'CMD = play Melody/Pattern aus Soundpuffer-RAM, warten bis Ende (expected Command + Pattern-Nr.)?
   if_z           jmp #memsnd_nr_wait             'ja
                  cmp cmdnr, #$4B           wz    'CMD = play beep aus Propeller-RAM, warten bis Ende (expected Command + Beep-Nr.)?
   if_z           jmp #membeep_nr_wait            'ja
                  cmp cmdnr, #$4C           wz    'CMD = play note aus Propeller-RAM (expected Command + Beep-Nr.)?
   if_z           jmp #membeep_nr                 'ja
                  cmp cmdnr, #$4F           wz    'CMD = einlesen Data-Block nach Soundpuffer?
   if_z           jmp #rdsnddata                  'ja
   
                  jmp #Cmdxx
                       
'......Get_Info .......................................................................................

get_info          cmp cmdnr, #$E5           wz    'CMD = Spin-Routinen ready (expected Command, write back 1 Statusbyte)?      
   if_z           jmp #spinrdy                    'ja
                  cmp cmdnr, #$E4           wz    'CMD = ermitteln Systemfrequenz in Hz?
   if_z           rdlong temp2, sysfrq_adr        'ja, dann einlesen
   if_z           jmp #outlongjmp                 'und ausgeben, sonst
                  cmp cmdnr, #$E1           wz    'CMD = ermitteln Bitmappuffer (Start;Lnge)?
   if_z           mov temp2, bmp_buff             'ja
   if_z           mov temp3, len_bmp              'Lnge nach Variable
   if_z           shl temp3, #2                   'Anzahl Longs *4 --> Anzahl in Byte
                  cmp cmdnr, #$E2           wz    'CMD = ermitteln Colorpuffer(Start;Lnge)?
   if_z           mov temp2, col_buff             'ja
   if_z           mov temp3, len_col
                  cmp cmdnr, #$E3           wz    'CMD = ermitteln Soundpuffer(Start;Lnge)?
   if_z           mov temp2, sndbuff_adr          'ja
   if_z           mov temp3, len_snd_mem

                  call #outlong2                  'verarbeiten und per Long ausgeben
 
                  jmp #Cmdxx
                  
'......Steuerung.......................................................................................

control           cmp cmdnr, #$FF           wz    'CMD = REBOOT Propeller?
   if_z           clkset $80                      'ja
                  cmp cmdnr, #$FE           wz    'CMD = Master-Cmd an Cog0 (Spin-Cog)?
   if_z           jmp #master                     'ja
                  cmp cmdnr, #$F9           wz    'CMD = Frequenz setzen?
   if_z           jmp #setfreq                    'ja
   
'......Blockbefehle....................................................................................
                  call #blockpara                 'Block-Parameter einlesen nach Pointer 
                  cmp cmdnr, #$FA           wz    'CMD = einlesen Data_Block per bitbang nach Hub-Ram (expected Command,Adresse,Lnge)?
   if_z           call #read_block_bb   
                  cmp cmdnr, #$FB           wz    'CMD = einlesen Data_Block als Longs nach Hub-Ram (expected Command,Adresse,Lnge)?
   if_z           call #rd_block_long   
                  cmp cmdnr, #$FC           wz    'CMD = schreiben Data_Block aus Hub-Ram (expected Command,Adresse,Lnge)?
   if_z           call #wr_block                  'Daten ausgeben    
                  cmp cmdnr, #$FD           wz    'CMD = einlesen Data_Block byteweise nach Hub-Ram (expected Command,Adresse,Lnge,Daten)?
   if_z           call #read_block                'Datenblock einlesen                                                
                  jmp  #Cmdxx                     'jump back
                  
'------------------------------------------------------------------------------------------------------                    
'---- Commands ----------------------------------------------------------------------------------------                   
'------------------------------------------------------------------------------------------------------
master            call #byte_in                   'Byte einlesen
                  wrlong temp2, mastercmd_adr     'und nach Merkzelle im HUB speichern
                  jmp  #Cmdxx                     'und zurck
                  
'------------------------------------------------------------------------------------------------------           
setfreq           mov temp3, temp2                'Cmd retten
                  call #getlong                   'Frequenzwert in Hz (4 Byte) einlesen
                  wrlong temp2, sysfrq_adr        'und nach Merkzelle im HUB speichern 
                  jmp  #lbla                      'Sprung zur Weiterverarbeitung
                  
'------------------------------------------------------------------------------------------------------ 
keyb1             rdlong temp2, key_dat           'letzten Tastaturabfragewert lesen
                  call #Propwrite                 'und ausgeben
                  mov temp2, #$0                  'lschen 
                  wrlong  temp2, key_dat          'der bergabezelle
                  jmp  #Cmdxx                     'und zurck
                  
'------------------------------------------------------------------------------------------------------ 
keyb2             rdlong temp2, key_dat           'letzten Tastaturabfragewert lesen
                  call #Propwrite                 'und ausgeben
                  jmp  #Cmdxx                     'und zurck
                  
'-------------------------------------------------------------------------------------------------------
screen            mov len_ptr, len                'Lnge TINY-BWS nach Pointer
                  mov scr_ptr, scr_buff           'Adresse Ziel im Hub nach Pointer
                  rdlong temp2, sysfrq_adr        'Taktfrequenz holen und
                  cmp temp2, frq_switch      wc   'Vergleich mit Schaltschwelle
   if_nc          jmp  #bb                        'wenn Takt > Schwelle, dann Sprung, sonst
                  call #read_block                'normales einlesen TINY-BWS --> Prop Hub_Ram
                  jmp  #Cmdxy                     'und zurck
bb                call #read_block_bb             'schnelles einlesen TINY-BWS --> Prop Hub_Ram
                  jmp  #Cmdxy                     'und zurck 
                  
'------------------------------------------------------------------------------------------------------
colxx             mov len_ptr, len_col            'Lnge Farbspeicher nach Pointer
                  mov scr_ptr, col_buff           'Adresse Farbspeicher nach Pointer
                  call #rd_block_word             'Farbspeicher einlesen und setzen
                  jmp #Cmdxx                      'und zurck  
                  
'------------------------------------------------------------------------------------------------------
colfgbg           call #getword                   'einheitliche Farbwerte fr Vorder- und hintergrund lesen
                  wrword temp2, calc_adr          'Long nach bergabezelle Daten fr Berechnungs-Cog 
                  jmp #Cmdxy                      'und zurck
                  
'------------------------------------------------------------------------------------------------------
set_moni          call #getlong                   'Ausgabemodus einlesen (4 Bytes)
                  wrlong temp2, vgamode_adr       'und nach Merkzelle fr Berechnung schreiben
                  shr temp2, #1                   'Tile-Mode extrahieren und
                  and temp2, #1                   'maskieren
                  wrlong temp2, mode_b_adr        'nach Merkzelle schreiben
                  jmp #Cmdxy                      'und zurck
                  
'------------------------------------------------------------------------------------------------------     
set_bmp           mov len_ptr, len_bmp            'Lnge Bitmap-Puffer nach Pointer
                  mov scr_ptr, bmp_buff           'Adresse Bitmap-Puffer nach Pointer
                  call #rd_block_long             'blockweise als Long einlesen
                  jmp #Cmdxx                      'und zurck 
                                     
'------------------------------------------------------------------------------------------------------     
cls_bmp           mov temp2, #0                   'Long-Wert = 0 fr Lschen Bitmappuffer
                  jmp #wr1ma                     
'----------------                 ---------------------------------------------------------------------     
wr1_bmp           call #getlong                   'Einlesen Long 
wr1ma             wrlong temp2, calc_adr          'Long nach bergabezelle Daten fr Berechnungs-Cog
                  jmp #Cmdxy                      'und zurck

'------------------------------------------------------------------------------------------------------     
pininfo           mov temp2, ina                  'alle Pins einlesen
                  shr temp2, #24                  'nach rechts verschieben
                  call #Propwrite                 'ausgeben ber Bus
                  jmp #Cmdxx                      'und zurck  
                  
'------------------------------------------------------------------------------------------------------
seriostat         call #testserrdy                'Status serieller Treiber holen
                  jmp #Cmdxx                      'und zurck  
                  
'------------------------------------------------------------------------------------------------------      
serout1           call #testserrdy                'Status serieller Treiber holen
                  test temp, #$02           wz    'vgl. auf Bereitschaft
            if_z  jmp #Cmdxx                      'zurck, wenn nicht bereit
seroutbyte        call #byte_in                   'sonst Datenbyte einlesen und
                  wrlong temp2, TxPtr             'zum Puffer des Treibers bergeben 
                  jmp #Cmdxx                      'und zurck
                                                  
'------------------------------------------------------------------------------------------------------
serout2           call #byte2serout               'Byte ausgeben mit warten auf Bereitschaft
                  jmp #Cmdxx                      'und zurck
                  
'------------------------------------------------------------------------------------------------------
rdtxdata          call #getword                   'Anzahl Bytes einlesen
                  mov temp_cnt, temp2             'und nach Zhler
:ma               call #byte2serout               'Byte holen und ausgeben, ggf. warten
                  djnz temp_cnt,#:ma              'Zhler -1 und zurck zum Byte holen bis Zhler=0
                  jmp #Cmdxx                      'und zurck
                  
'------------------------------------------------------------------------------------------------------
serin0            call #serinbyte                 'Pufferzelle einlesen
                  jmp #Cmdxx                      'und zurck 
                  
'------------------------------------------------------------------------------------------------------   
serin1            call #testserrdy                'Status serieller Treiber holen
                  test temp, #$01           wz    'Test, ob Byte im Puffer
            if_z  jmp #Cmdxx                      'zurck, wenn nicht  
                  rdlong temp2, RxPtr             'Byte vom Puffer einlesen
                  call #serin2byte2               'und ausgeben
                  jmp #Cmdxx                      'und zurck 
                   
'------------------------------------------------------------------------------------------------------  
serin2            call #serin2byte                'Byte einlesen mit ggf. warten
                  jmp #Cmdxx                      'und zurck 

'------------------------------------------------------------------------------------------------------  
wrrxdata          call #getword                   'Anzahl Bytes einlesen
                  mov temp_cnt, temp2             'und nach Zhler
:ma               call #serin2byte                'Byte einlesen mit ggf. warten 
                  djnz temp_cnt,#:ma              'Zhler -1 und zurck zum Einlesen Byte bis Zhler=0
                  jmp #Cmdxx                      'und zurck
                  
'------------------------------------------------------------------------------------------------------
sndrdy            mov temp, #4                    'Testlabel fr Spin-Routinen Sound 
                  jmp #mardy  
spinrdy           mov temp, #0                    'Testlabel fr Spin-Routinen gesamt
mardy             call #testspinrdy               'Bereitschaft testen und Status ausgeben
                  jmp #Cmdxx                      'und zurck
 
'------------------------------------------------------------------------------------------------------
snd_nr_wait       call #snd_wait                  'warten auf Ende vorhergehende Ausgabe 
'----------------                ----------------------------------------------------------------------   
snd_nr            mov temp3, temp2                'Cmd retten 
                  call #byte_in                   '1 Datenbyte einlesen (Sub-Cmd)
                  shl temp3, #8                   'Cmd ein Byte nach links $0000_XXxx
                  or temp2, temp3                 'Cmd + Sub-Cmd
                  jmp #snd_ma
                  
'-------------------------------------------------------------------------------------------------------   
snd_get           mov temp3, temp2                'Cmd retten
                  call #getlong                   '4 Datenbytes einlesen
snd4              wrlong temp2, data_adr          'nach Sounddaten speichern
lbla              mov temp2, temp3                'Cmd zurckholen
'-------------                           ---------------------------------------------------------------   
beep              shl temp2, #8                   'Cmd ein Byte nach links $0000_XXxx
snd_ma            wrlong temp2, full_cmd          'nach Soundcommand speichern
                  jmp #Cmdxx                      'und zurck

'------------------------------------------------------------------------------------------------------
memsnd_nr_wait    call #snd_wait                  'warten auf Ende vorhergehende Ausgabe 
'----------------                ---------------------------------------------------------------------- 
memsnd_nr         mov temp3, temp2                'Cmd retten 
                  call #byte_in                   '1 Datenbyte einlesen (Sub-Cmd = Nr.)
                  mov temp, temp2                 'und nach Zhler schreiben
                  mov scr_ptr, sndbuff_adr        'Anfangsadr. Memory nach scr_ptr
                  mov label, plabel               'label ist Pattern-end
                  call # mem_srch                 'Nr. suchen
                  jmp #snd4                       'Adresse nach Sounddaten, Cmd nach Soundcommand
                  
'-------------------------------------------------------------------------------------------------------                    
membeep_nr_wait   call #snd_wait                  'warten auf Ende vorhergehende Ausgabe
'----------------                ----------------------------------------------------------------------- 
membeep_nr        mov temp3, temp2                'Cmd retten
                  mov scr_ptr, sndbuff_adr        'Anfangsadr. Memory nach scr_ptr
                  call #byte_in                   '1 Datenbyte einlesen (Sub-Cmd = Nr.)
                  add scr_ptr, temp2              'berechnen Speicheradresse
                  rdlong temp2, scr_ptr           'auslesen Daten von Adresse
                  jmp #snd4                       'Daten nach Sounddaten, Cmd nach Soundcommand
                  
'------------------------------------------------------------------------------------------------------- 
rdsnddata         mov len_ptr, len_snd_mem        'Lnge Soundbuffer nach Pointer
                  mov scr_ptr, sndbuff_adr        'Adresse Soundbuffer nach Pointer 
                  call #read_block                'Datenblock einlesen 
                  jmp #Cmdxx                      'und zurck
                  

'------------------------------------------------------------------------------------------------------- 

                 
'=======================================================================================================
'---- Common -Parts  -----------------------------------------------------------------------------------
'-------------------------------------------------------------------------------------------------------
testspinrdy       rdlong temp2, full_cmd          'Status Spin-Cmd einlesen
                  shr temp2, #12                  'um 3 Bytes nach rechts verschieben
                  cmp temp2, temp           wz    'vgl. auf Bereitschaft 
            if_z  mov temp2, #$80                 'setze Wert, wenn bereit
            if_nz mov temp2, #$FF                 'setze Wert, wenn nicht bereit
                  jmp #my1
'----------------                      -----------------------------------------------------------------   
testserrdy        mov temp2, #0
                  rdlong temp, TxPtr              'Check the transmitter 
                  shl temp ,#1              WC    'Carry set if transmitter is idle         
                  rcl temp2,#1
                  rdlong temp, RxPtr              'Check the receiver
                  shl temp ,#1              WC    'Carry set if receiver is idle
                  rcl temp2,#1
my1               mov temp, temp2                 'rette Status nach temp 
                  call #Propwrite                 'ausgeben Wert ber Bus
testspinrdy_ret
testserrdy_ret    ret

'-------------------------------------------------------------------------------------------------------
snd_wait          rdlong temp, full_cmd           'Status Sound-Cmd einlesen
                  cmp temp, #$00            wz    'vgl. auf Bereitschaft
           if_nz  jmp #snd_wait                   'solange nicht bereit zurck zum einlesen 
snd_wait_ret      ret


'=======================================================================================================


'*********************************************************************************************************
'---- Subroutines to read/write byte etc.-----------------------------------------------------------------
'*********************************************************************************************************
Propwrite         mov temp3, handshake             '0000_0C00
                  or temp3, data_mask              '0000_0CFF
               '   shl temp2, data0                 'verschieben Byte nach IO-Pin
                  and temp2, data_mask             '0000_00xx
                  or temp2, drdy_val               '0000_08xx drdy = L in temp2
                  mov outa, temp2                  'vorweg in outa schreiben
                  waitpne wrbus_mask,wrbus_mask    'warten auf RD des Z8 = L
                  mov dira, temp3                  'Datenbus auf Ausgang
                  waitpeq wrbus_mask,wrbus_mask    'warten bis RD des Z8 = H
                  mov dira, handshake              'Datenbusrichtung auf Eingang
                  mov outa, handshake              'drdy und crdy = H
Propwrite_ret     ret

'--------------------------------------------------------------------------------------------------------
Propread          mov outa, drdy_val               'drdy = L
Propread2         mov dira, handshake              'nur handshakepins auf Ausgang 
                  waitpne rdbus_mask,rdbus_mask    'Warten bis WR des Z8 =L  
                  mov temp2, ina                   'Einlesen aller Pins
                  waitpeq rdbus_mask,rdbus_mask    'Warten bis WR des Z8 =H
                  mov outa, handshake              'drdy und crdy = H
               '   shr temp2, data0                 'verschieben IO-Pin nach Byte 
Propread2_ret
Propread_ret      ret

'--------------------------------------------------------------------------------------------------------
cmdwait           mov outa, crdy_val               'setze "Ready for Command"
                  call #Propread2                  'Byte einlesen
                  and  temp2, data_mask            'ausblenden unntiger Bits
                  cmp  cmdlabel, temp2       wz    'Vgl. mit bergebenem Byte 
   if_nz          jmp  #cmdwait     
cmdwait_ret       ret

'---------------------------------------------------------------------------------------------------------
byte_in           call #Propread                   'einlesen IO-Pins
                  and temp2, data_mask             'lschen unntiger Bits
byte_in_ret       ret

'---------------------------------------------------------------------------------------------------------
getword           mov temp_cnt, #2                 'Bytezhler = 2
                  jmp # getxx
'---------------------------------------------------------------------------------------------------------         
getlong           mov temp_cnt, #4                 'Bytezhler = 4
getxx             mov temp, #0                     'Variable lschen
:my_cnt           call #byte_in                    'Byte einlesen
                  shl temp, #8                     'in Varable Inhalt 8 Bit nach links 
                  or temp, temp2                   'gelesenes Byte einfgen
                  djnz temp_cnt, #:my_cnt          'zurck, solange Bytezhler nicht 0
                  mov temp2, temp                  'nach Rckgabe-Variable schreiben
getword_ret
getxx_ret                  
getlong_ret       ret

'------------------------------------------------------------------------------------------------------   
rd_block_long     call #getlong                     'Long einlesen
                  wrlong temp2, scr_ptr             'Adresse bescheiben 
                  add scr_ptr, #4                   'nchste Long-Adresse
                  djnz len_ptr, #rd_block_long      'zurck, wenn Lnge grer 0
rd_block_long_ret ret

'------------------------------------------------------------------------------------------------------
rd_block_word     call #getword                     'Word einlesen
                  wrword temp2, scr_ptr             'nach HUB-Ram auf Pointeradresse schreiben
                  add scr_ptr, #2                   'Pointer ein Word weiter setzen
                  djnz len_ptr, #rd_block_word      'zurck, solange Lnge nicht 0
rd_block_word_ret ret
 
'------------------------------------------------------------------------------------------------------
read_block        call #Propread
                  wrbyte temp2, scr_ptr
                  add scr_ptr, #1  
                  djnz len_ptr, #read_block
read_block_ret    ret

'------------------------------------------------------------------------------------------------------
read_block_bb     mov outa, drdy_val                'drdy = L
                  mov dira, handshake               'nur handshakepins auf Ausgang 
readbb            waitpne rdbus_mask,rdbus_mask     'Warten bis WR des Z8 =L
                  mov temp2, ina
               '   shr temp2, data0                  'verschieben IO-Pin nach Byte
                  wrbyte temp2, scr_ptr
                  add scr_ptr, #1
              '   waitpeq rdbus_mask,rdbus_mask     'Warten bis WR des Z8 =H bei Bedarf                    
                  djnz len_ptr, #readbb
                  mov outa, handshake              'drdy und crdy = H            
read_block_bb_ret ret

'---------------------------------------------------------------------------------------------------------
outlong2          shl temp2, #16
                  or temp2, temp3
outlong           mov temp, temp2 
                  mov temp_cnt, #4
:my_cnt           rol temp, #8
                  mov temp2, temp
                  call #Propwrite
                  djnz temp_cnt, #:my_cnt
outlong2_ret 
outlong_ret       ret
'---------------------------------------------------------------------------------------------------------
outlongjmp        call #outlong
                  jmp #Cmdxx

'---------------------------------------------------------------------------------------------------------    
wr_block          rdbyte temp2, scr_ptr
                  call #Propwrite
                  add scr_ptr, #1
                  djnz len_ptr, #wr_block
wr_block_ret      ret

'------------------------------------------------------------------------------------------------------- 
blockpara         call #getword                   'Ziel-Adresse Hub-Ram einlesen
                  mov scr_ptr, temp2              'nach Pointer schreiben
                  call #getword                   'Anzahl Bytes einlesen
                  mov len_ptr, temp2              'nach Pointer schreiben
blockpara_ret     ret

'---------------------------------------------------------------------------------------------------------  
mem_srch          rdlong temp2, scr_ptr           'einlesen Inhalt
                  cmp temp2, label           wz   'vgl mit label
                  add temp2, #4                   'nchste Adresse
          if_nz   jmp #mem_srch                   'zurck, solange Inhalt ungleich label
                  djnz temp, #mem_srch            'sonst Zhler -1 und zurck bis Zhler =0
mem_srch_ret      ret

'---------------------------------------------------------------------------------------------------------
byte2serout       call #byte_in                   'Datenbyte einlesen und 
:ma               rdlong temp,TxPtr               'Check the transmitter                                   
                  shl temp,#1                WC   'Carry set if transmitter is idle     
           if_nc  jmp #:ma                        'Wait til the transmitter is idle
                  wrlong temp2,TxPtr              'Write the byte into the transmitter
byte2serout_ret   ret

'---------------------------------------------------------------------------------------------------------
serinbyte         rdlong temp2, RxPtr             'Check the receiver
                  jmp #modex
serin2byte        rdlong temp2, RxPtr             'Check the receiver                                   
                  shl temp2, #1              WC   'Carry set if no byte available
                  shr temp2, #1      
           if_c   jmp #serin2byte                 'Wait for a byte to be received                                   
serin2byte2       wrlong MinusOne, RxPtr          'Mark the byte as having been read 
modex             cmp RxMode, #1             wz   'Tx-Mode =1?
           if_z   neg temp2, temp2                'ja, negate Data
                  and temp2, #$FF                 'set highest 3 Bytes always zero
                  call # Propwrite
modex_ret
serinbyte_ret                  
serin2byte2_ret                  
serin2byte_ret    ret                                    
'---------------------------------------------------------------------------------------------------------

'*********************************************************************************************************      
  

'*********************************************************************************************************
'---- Data & Variable ------------------------------------------------------------------------------------
'*********************************************************************************************************                    
 
 handshake     long  0
 crdy_val      long  0
 drdy_val      long  0
 rdbus_mask    long  0
 wrbus_mask    long  0
 data_mask     long  0
 data0         long  0
 cmdlabel      long  0
 scr_buff      long  0      
 bmp_buff      long  0
 col_buff      long  0
 sndbuff_adr   long  0
 len           long  lenx
 len_col       long  lencol*2
 len_bmp       long  lenbmp
 len_snd_mem   long  lensndmem
 vgamode_adr   long  0 
 mode_b_adr    long  0
 mastercmd_adr long  0                                
 key_dat       long  0     
 RxPtr         long  0             
 TxPtr         long  0              
 data_adr      long  0
 calc_adr      long  0
 full_cmd      long  0
 calc_cmd      long  0
 sysfrq_adr    long  0
 frq_switch    long  16_000000
 plabel        long  $FFFF_FFFF
 MinusOne      long  -1
 cmdnr         long  0
 
Mem            res   1
temp           res   1
temp2          res   1
temp3          res   1
temp_cnt       res   1
 
scr_ptr        res   1
scr_end        res   1 
bmp_ptr        res   1
len_ptr        res   1

label          res   1
cmdgroup       res   1

fit